function varargout = experiment(varargin)
%--------------------------------------------------------------------------
%                     RAWSEEDS VISUALIZATION TOOLKIT
%--------------------------------------------------------------------------
%   function  experiment()
%
%   EXPERIMENT loads the GUI for visualization of all sensors used in each
%   RAWSEEDS' experiment.
%
%   Authors: C. Cadena & J. Neira, University of Zaragoza, Spain
%--------------------------------------------------------------------------
%   Version: 1.0    nov-2010
%--------------------------------------------------------------------------
%   History:
%--------------------------------------------------------------------------

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       'experiment', ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @experiment_OpeningFcn, ...
                   'gui_OutputFcn',  @experiment_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT

% --- Executes just before experiment is made visible.
function experiment_OpeningFcn(hObject, eventdata, handles, varargin)

handles.output = hObject;
guidata(hObject, handles);
im=imread('rawseeds.bmp');

axes(handles.svsT);
imshow(rgb2gray(imresize(im,[480,640])));
axes(handles.svsL);
imshow(rgb2gray(imresize(im,[480,640])));
axes(handles.svsR);
imshow(rgb2gray(imresize(im,[480,640])));

axes(handles.Omni);
imshow(imresize(im,[640,640]));
set(handles.Omni,'XLimMode','auto','YLimMode','auto');

axes(handles.Frontal);
imshow(imresize(im,[240,320]));
set(handles.Frontal,'XLimMode','auto','YLimMode','auto');

axes(handles.traj);
plot(0,0,'--b*'), hold on, plot(0,0,'--ro');
legend('Odometry','Ground Truth','location','SouthEast');
axis equal;

axes(handles.laser)
set(handles.laser,'Color',[0.941 0.941 0.941])
hp=patch(0,0, 'w'); set(hp,'EdgeColor',[0.5,0.5,0.5]);
hp=patch(0,0, 'w'); set(hp,'EdgeColor',[0.5,0.5,0.5]);
hp=patch(0,0, 'c'); set(hp,'EdgeColor',[0.5,1,1],'FaceColor',[0.9,1,1],'FaceAlpha',0.9);
hp=patch(0,0, 'm'); set(hp,'EdgeColor',[1,0.8,0.8],'FaceColor',[1,0.95,0.95],'FaceAlpha',0.9);
axis equal; axis([-82,82,-82,82]);

axes(handles.imu_a)
h=quiver3(0,0,9.8,0,0,0); set(h,'LineWidth',10,'Color',[1,0.7,0.7]); hold on
h=quiver3(0,0,9.8,0,0,0); set(h,'LineWidth',10,'Color',[0.7,0.7,1]);
h=quiver3(0,0,9.8,0,0,0); set(h,'LineWidth',10,'Color',[0.7,1,0]);
set(handles.imu_a,'Color',[0.941 0.941 0.941]);
axis equal
axis([-1 1 -1 1 9.5 11]);
text(0.5,-0.1,9.8,'X');
text(0,0.5,9.9,'Y');
text(0,-0.1,10.3,'Z');
h=quiver3(0,0,9.8,1,0,0); set(h,'LineWidth',1,'Color',[0,0,1],'MaxHeadSize',1);
h=quiver3(0,0,9.8,0,1,0); set(h,'LineWidth',1,'Color',[0,1,0],'MaxHeadSize',1);
h=quiver3(0,0,9.8,0,0,1); set(h,'LineWidth',1,'Color',[1,0,0],'MaxHeadSize',1);
axes(handles.imu_w)
h=bar([1,2,3],[0,0,0]); set(h,'FaceColor',[1,0.7,0.7],'EdgeColor',[1,0.7,0.7]);
hold on
h=bar([1,2,3],[0,0,0]); set(h,'FaceColor',[0.7,1,0.7],'EdgeColor',[0.7,1,0.7]);
h=bar([1,2,3],[0,0,0]); set(h,'FaceColor',[0.7,0.7,1],'EdgeColor',[0.7,0.7,1]);
axis([0.5 3.5 -0.8 0.8]);
set(handles.imu_w,'Color',[0.941 0.941 0.941],'XTickLabel',['X';'Y';'Z'],...
    'Box','off');

% --- Outputs from this function are returned to the command line.
function varargout = experiment_OutputFcn(hObject, eventdata, handles) 
varargout{1} = handles.output;

% --- Executes on button press in play_pause.
function play_pause_Callback(hObject, eventdata, handles)
while get(hObject,'Value')
    jump=get(handles.sjump,'Value');
    if jump<0.0333, jump=0.0333; end
    refresh_screen(handles,jump);
    if get(hObject,'Value')
        set(handles.play_pause,'string','Pause');
    else
        set(handles.play_pause,'string','Play');
    end
end
% --- Executes on button press in nframe.
function nframe_Callback(hObject, eventdata, handles)
set(handles.play_pause,'string','Play','Value',0);
jump=get(handles.sjump,'Value');
if jump<0.0333, jump=0.0333; end
refresh_screen(handles,jump);

% --- Executes on button press in pframe.
function pframe_Callback(hObject, eventdata, handles)
set(handles.play_pause,'string','Play','Value',0);
jump=get(handles.sjump,'Value');
if jump<0.0333, jump=0.0333; end
refresh_screen(handles,-jump);

% --- Executes on button press in stop.
function stop_Callback(hObject, eventdata, handles)
set(handles.play_pause,'string','Play','Value',0);
set(handles.txt,'string','0');

function txt_Callback(hObject, eventdata, handles)
global timestamps
if isnan(str2double(get(hObject,'String')))
    set(handles.txt,'string',num2str(0));
end
if str2double(get(hObject,'String'))>(timestamps.final-timestamps.start)
    set(handles.txt,'string',num2str(timestamps.final-timestamps.start));
end
% --- Executes during object creation, after setting all properties.
function txt_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'),...
        get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

% --- Executes on slider movement.
function sjump_Callback(hObject, eventdata, handles)
jump=get(handles.sjump,'Value');
if jump<0.0333, jump=0.0333; set(handles.sjump,'Value',0.0333); end
set(handles.txtJ,'string',num2str(jump));

% --- Executes during object creation, after setting all properties.
function sjump_CreateFcn(hObject, eventdata, handles)
if isequal(get(hObject,'BackgroundColor'),...
        get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor',[.9 .9 .9]);
end

% --- Executes on button press in checkLeft.
function checkLeft_Callback(hObject, eventdata, handles)

% --- Executes on button press in checkOmni.
function checkOmni_Callback(hObject, eventdata, handles)

% --- Executes on button press in checkTraj.
function checkTraj_Callback(hObject, eventdata, handles)

% --- Executes on button press in checkRight.
function checkRight_Callback(hObject, eventdata, handles)

% --- Executes on button press in checkLaser.
function checkLaser_Callback(hObject, eventdata, handles)

% --- Executes on button press in checkTop.
function checkTop_Callback(hObject, eventdata, handles)

% --- Executes on button press in checkFrontal.
function checkFrontal_Callback(hObject, eventdata, handles)

% --- Executes on button press in checkIMU.
function checkIMU_Callback(hObject, eventdata, handles)


function txtJ_Callback(hObject, eventdata, handles)
if isnan(str2double(get(hObject,'String')))
    set(handles.txtJ,'string',round(num2str(get(handles.sjump,'Value'))));
elseif str2double(get(hObject,'String'))>get(handles.sjump,'Max')
    set(handles.txtJ,'string',num2str(get(handles.sjump,'Max')));
elseif str2double(get(hObject,'String'))<get(handles.sjump,'Min')+1
    set(handles.txtJ,'string',num2str(get(handles.sjump,'Min')+1));
else
    set(handles.sjump,'Value',round(str2double(get(hObject,'String'))));
end

% --- Executes during object creation, after setting all properties.
function txtJ_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'),...
        get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

function refresh_screen(handles,jump)

global PARAMETERS timestamps DATA
    
ind=str2double(get(handles.txt,'string'));
if ind+jump<(timestamps.final-timestamps.start) && ind+jump>0
    ind=ind+jump;
    set(handles.txt,'string',num2str(ind));
end

hT=get(handles.svsT);
hR=get(handles.svsR);
hL=get(handles.svsL);
hF=get(handles.Frontal);
hO=get(handles.Omni);
hTraj=get(handles.traj);
hlaser=get(handles.laser);
hIMUa=get(handles.imu_a);
hIMUw=get(handles.imu_w);

timestamps.current=timestamps.start+ind;

if exist([PARAMETERS.folder,'SVS_T'],'dir') && get(handles.checkTop,'Value')
    iT=find(timestamps.tT<=timestamps.current,1,'last');
    if ~isempty(iT)
        if exist([PARAMETERS.folder,'SVS_T/SVS_T_',...
                num2str(timestamps.tT(iT),'%3.6f'),'.png'],'file')
            imT=imread([PARAMETERS.folder,'SVS_T/SVS_T_',...
                num2str(timestamps.tT(iT),'%3.6f'),'.png']);
            set(hT.Children,'CData',imT)
            set(handles.textT,'string',['Top : ',num2str(timestamps.tT(iT),'%3.4f'),' s']);
        end
    end
end
if exist([PARAMETERS.folder,'SVS_L'],'dir') && get(handles.checkLeft,'Value')
    iL=find(timestamps.tL<=timestamps.current,1,'last');
    if ~isempty(iL)
        if exist([PARAMETERS.folder,'SVS_L/SVS_L_',...
                num2str(timestamps.tL(iL),'%3.6f'),'.png'],'file')
            imL=imread([PARAMETERS.folder,'SVS_L/SVS_L_',...
                num2str(timestamps.tL(iL),'%3.6f'),'.png']);
            set(hL.Children,'CData',imL)
            set(handles.textL,'string',['Left : ',num2str(timestamps.tL(iL),'%3.4f'),' s']);
        end
    end
end
if exist([PARAMETERS.folder,'SVS_R'],'dir') && get(handles.checkRight,'Value')
    iR=find(timestamps.tR<=timestamps.current,1,'last');
    if ~isempty(iR)
        if exist([PARAMETERS.folder,'SVS_R/SVS_R_',...
                num2str(timestamps.tR(iR),'%3.6f'),'.png'],'file')
            imR=imread([PARAMETERS.folder,'SVS_R/SVS_R_',...
                num2str(timestamps.tR(iR),'%3.6f'),'.png']);
            set(hR.Children,'CData',imR)
            set(handles.textR,'string',['Right : ',num2str(timestamps.tR(iR),'%3.4f'),' s']);
        end
    end
end
if exist([PARAMETERS.folder,'FRONTAL'],'dir') && get(handles.checkFrontal,'Value')
    iF=find(timestamps.tF<=timestamps.current,1,'last');
    if ~isempty(iF)
        if exist([PARAMETERS.folder,'FRONTAL/FRONTAL_',...
                num2str(timestamps.tF(iF),'%3.6f'),'.png'],'file')
            imF=imread([PARAMETERS.folder,'FRONTAL/FRONTAL_',...
                num2str(timestamps.tF(iF),'%3.6f'),'.png']);
            set(hF.Children,'CData',imF)
            set(handles.textF,'string',['Frontal : ',num2str(timestamps.tF(iF),'%3.4f'),' s']);
        end
    end
end
if exist([PARAMETERS.folder,'OMNI'],'dir') && get(handles.checkOmni,'Value')
    iO=find(timestamps.tO<=timestamps.current,1,'last');
    if ~isempty(iO)
        if exist([PARAMETERS.folder,'OMNI/OMNI_',...
                num2str(timestamps.tO(iO),'%3.6f'),'.png'],'file')
            imO=imread([PARAMETERS.folder,'OMNI/OMNI_',...
                num2str(timestamps.tO(iO),'%3.6f'),'.png']);
            set(hO.Children,'CData',imO)
            set(handles.textO,'string',['Omni : ',num2str(timestamps.tO(iO),'%3.4f'),' s']);
        end
    end
end
if isfield(DATA,'odometry') && get(handles.checkTraj,'Value')
    iOD=find(timestamps.OD<=timestamps.current,1,'last');
    if ~isempty(iOD)
        xo=DATA.odometry(1:iOD,5);
        yo=DATA.odometry(1:iOD,6);
        %theta=DATA.odometry(1:iOD,7);
        set(hTraj.Children(2),'XData',xo,'YData',yo);
    end
end
if isfield(DATA,'GT') && get(handles.checkTraj,'Value')
    iGT=find(timestamps.GT<=timestamps.current,1,'last');
    if ~isempty(iGT)
        xgt=DATA.GT(1:iGT,2);
        ygt=DATA.GT(1:iGT,3);
        %theta=DATA.GT(1:i,4);
        set(hTraj.Children(1),'XData',xgt,'YData',ygt);
    end
end
if isfield(DATA,'SF') && get(handles.checkLaser,'Value')
    iSF=find(timestamps.SF<=timestamps.current,1,'last');
    if ~isempty(iSF)
        Q = scan2cart(DATA.SF(iSF,4:end),80,(-90:90)*pi/180);
        set(hlaser.Children(4),'XData',[0,Q(1,:)]+0.08,'YData',[0,Q(2,:)]);
    end
end
if isfield(DATA,'SR') && get(handles.checkLaser,'Value')
    iSR=find(timestamps.SR<=timestamps.current,1,'last');
    if ~isempty(iSR)
        Q = scan2cart(DATA.SR(iSR,4:end),80,(90:270)*pi/180);
        set(hlaser.Children(3),'XData',[0,Q(1,:)]-0.463,'YData',[0,Q(2,:)]);
    end
end
if isfield(DATA,'HF') && get(handles.checkLaser,'Value')
    iHF=find(timestamps.HF<=timestamps.current,1,'last');
    if ~isempty(iHF)
        Q = scan2cart(DATA.HF(iHF,2:end),5.6,(-120:360/1024:120)*pi/180);
        set(hlaser.Children(2),'XData',[0,Q(1,:)]+0.094,'YData',[0,Q(2,:)]);
    end
end
if isfield(DATA,'HR') && get(handles.checkLaser,'Value')
    iHR=find(timestamps.HR<=timestamps.current,1,'last');
    if ~isempty(iHR)
        Q = scan2cart(DATA.HR(iHR,2:end),5.6,(60:360/1024:300)*pi/180);
        set(hlaser.Children(1),'XData',[0,Q(1,:)]-0.463,'YData',[0,Q(2,:)]);
    end
end
if isfield(DATA,'IMU') && get(handles.checkIMU,'Value')
    iIMU=find(timestamps.IMU<=timestamps.current,1,'last');
    if ~isempty(iIMU)
        set(hIMUa.Children(8),'UData',DATA.IMU(iIMU,3));
        set(hIMUa.Children(7),'VData',DATA.IMU(iIMU,4));
        set(hIMUa.Children(9),'WData',DATA.IMU(iIMU,5)-9.8);
        set(hIMUw.Children(1),'YData',[DATA.IMU(iIMU,6),0,0]);
        set(hIMUw.Children(2),'YData',[0,DATA.IMU(iIMU,7),0]);
        set(hIMUw.Children(3),'YData',[0,0,DATA.IMU(iIMU,8)]);
        set(handles.textIMU,'string',['IMU : ',num2str(timestamps.IMU(iIMU),'%3.4f'),' s']);
    end
end
drawnow;

function Q = scan2cart(scan,maxdist,angles)

valid = find(scan < maxdist);
[x,y] = pol2cart(angles(valid), scan(valid));
Q=[x;y];
