function varargout = frontal(varargin)

%--------------------------------------------------------------------------
%                     RAWSEEDS VISUALIZATION TOOLKIT
%--------------------------------------------------------------------------
%   function  frontal()
%
%   FRONTAL loads the GUI for visualization of the monocular colour
%   camera's images.
%
%   Authors: C. Cadena & J. Neira, University of Zaragoza, Spain
%--------------------------------------------------------------------------
%   Version: 1.0    nov-2010
%--------------------------------------------------------------------------
%   History:
%--------------------------------------------------------------------------

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       'frontal', ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @frontal_OpeningFcn, ...
                   'gui_OutputFcn',  @frontal_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT

% --- Executes just before frontal is made visible.
function frontal_OpeningFcn(hObject, eventdata, handles, varargin)

handles.output = hObject;
guidata(hObject, handles);
im=imread('rawseeds.bmp');
axes(handles.Frontal);
imshow(imresize(im,[240,320]));
set(handles.Frontal,'XLimMode','auto','YLimMode','auto')


% --- Outputs from this function are returned to the command line.
function varargout = frontal_OutputFcn(hObject, eventdata, handles) 
varargout{1} = handles.output;


% --- Executes on button press in play_pause.
function play_pause_Callback(hObject, eventdata, handles)

while get(hObject,'Value')
    refresh_screen(handles,1);
    if get(hObject,'Value')
        set(handles.play_pause,'string','Pause');
    else
        set(handles.play_pause,'string','Play');
    end
end

% --- Executes on button press in nframe.
function nframe_Callback(hObject, eventdata, handles)

set(handles.play_pause,'string','Play','Value',0);
refresh_screen(handles,1);

% --- Executes on button press in pframe.
function pframe_Callback(hObject, eventdata, handles)

set(handles.play_pause,'string','Play','Value',0);
refresh_screen(handles,-1);

% --- Executes on button press in stop.
function stop_Callback(hObject, eventdata, handles)

set(handles.play_pause,'string','Play','Value',0);
set(handles.txt,'string','0');

function txt_Callback(hObject, eventdata, handles)

global timestamps

if isnan(str2double(get(hObject,'String')))
    set(handles.txt,'string',num2str(0));
end
if str2double(get(hObject,'String'))>size(timestamps,1)
    set(handles.txt,'string',num2str(size(timestamps,1)));
end

% --- Executes during object creation, after setting all properties.
function txt_CreateFcn(hObject, eventdata, handles)

if ispc && isequal(get(hObject,'BackgroundColor'),...
    get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

function refresh_screen(handles,jump) 

global PARAMETERS timestamps

ind=str2double(get(handles.txt,'string'));
if ind<size(timestamps,1) && ind+jump>0
    ind=ind+jump;
    set(handles.txt,'string',num2str(ind));
end

hF=get(handles.Frontal);

if exist([PARAMETERS.folder,'FRONTAL'],'dir')
    if exist([PARAMETERS.folder,'FRONTAL/FRONTAL_',...
            num2str(timestamps(ind,1),'%3.6f'),'.png'],'file')
        imF=imread([PARAMETERS.folder,'FRONTAL/FRONTAL_',...
            num2str(timestamps(ind,1),'%3.6f'),'.png']);
        set(hF.Children,'CData',imF)
        set(handles.textF,'string',['Frontal : ',num2str(timestamps(ind,1),'%3.4f'),' s']);
    end
end
drawnow;
