%--------------------------------------------------------------------------
%                    RAWSEEDS VISUALIZATION TOOLKIT
%                       http://www.rawseeds.org/
%--------------------------------------------------------------------------
%   frontal_viewer.m
%
%   This script shows the images from the monocular colour camera of the 
%   selected RAWSEEDS dataset.
% 
%   For more information, refer to the project site: www.rawseeds.org
%
%   Authors: C. Cadena & J. Neira, University of Zaragoza, Spain
%--------------------------------------------------------------------------
%   Version: 1.0    20-nov-2009
%--------------------------------------------------------------------------
%   History:
%--------------------------------------------------------------------------

close all;
clear all;

global PARAMETERS timestamps

PARAMETERS.DataPath      = '../datasets'; % where the datasets are?
  
% PARAMETERS.DatasetName   = 'Bicocca_2009-02-25a';  % Indoor
  PARAMETERS.DatasetName   = 'Bicocca_2009-02-25b';  % Indoor
% PARAMETERS.DatasetName   = 'Bicocca_2009-02-26a';  % Indoor
% PARAMETERS.DatasetName   = 'Bicocca_2009-02-26b';  % Indoor
% PARAMETERS.DatasetName   = 'Bicocca_2009-02-27a';  % Indoor
% PARAMETERS.DatasetName   = 'Bovisa_2008-09-01_Static';   % Mixed
% PARAMETERS.DatasetName   = 'Bovisa_2008-10-06_Dynamic';  % Mixed
% PARAMETERS.DatasetName   = 'Bovisa_2008-10-11a_Static';  % Mixed
% PARAMETERS.DatasetName   = 'Bovisa_2008-10-04_Static';   % Outdoor
% PARAMETERS.DatasetName   = 'Bovisa_2008-10-07_Dynamic';  % Outdoor
% PARAMETERS.DatasetName   = 'Bovisa_2008-10-11b_Static';  % Outdoor

%% import sensor
folder=[PARAMETERS.DataPath,'/',PARAMETERS.DatasetName,'/'];
dataset=PARAMETERS.DatasetName;
ind_=find(dataset=='_',1,'last');
if ind_>9, dataset=dataset(1:ind_-1); end

PARAMETERS.dataset=dataset;
PARAMETERS.folder=folder;

disp('--------------------------------------------------------------------');
disp('                 RAWSEEDS VISUALIZATION TOOLKIT                     ');
disp('--------------------------------------------------------------------');

tF_file=[dataset,'-LISTS/',dataset,'-FRONTAL.csv'];

timestamps=importdata([folder,tF_file]);

disp('--------------------------------------------------------------------');
disp('                 Viewing: Frontal Colour Camera                      ');
disp('--------------------------------------------------------------------');

frontal;

