function varargout = omni(varargin)

%--------------------------------------------------------------------------
%                     RAWSEEDS VISUALIZATION TOOLKIT
%--------------------------------------------------------------------------
%   function  omni()
%
%   OMNI loads the GUI for visualization of the omnidirectional camera's
%   images. Note that the images are in the mirror.
%
%   Authors: C. Cadena & J. Neira, University of Zaragoza, Spain
%--------------------------------------------------------------------------
%   Version: 1.0    nov-2010
%--------------------------------------------------------------------------
%   History:
%--------------------------------------------------------------------------

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       'omni', ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @omni_OpeningFcn, ...
                   'gui_OutputFcn',  @omni_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT

% --- Executes just before omni is made visible.
function omni_OpeningFcn(hObject, eventdata, handles, varargin)

handles.output = hObject;
guidata(hObject, handles);
im=imread('rawseeds.bmp');
axes(handles.Omni);
imshow(imresize(im,[600,600]));
set(handles.Omni,'XLimMode','auto','YLimMode','auto')

% --- Outputs from this function are returned to the command line.
function varargout = omni_OutputFcn(hObject, eventdata, handles) 
varargout{1} = handles.output;


% --- Executes on button press in stop.
function stop_Callback(hObject, eventdata, handles)

set(handles.play_pause,'string','Play','Value',0);
set(handles.txt,'string','0');

% --- Executes on button press in play_pause.
function play_pause_Callback(hObject, eventdata, handles)

while get(hObject,'Value')
    refresh_screen(handles,1);
    if get(hObject,'Value')
        set(handles.play_pause,'string','Pause');
    else
        set(handles.play_pause,'string','Play');
    end
end

% --- Executes on button press in nframe.
function nframe_Callback(hObject, eventdata, handles)
set(handles.play_pause,'string','Play','Value',0);
refresh_screen(handles,1);

% --- Executes on button press in pframe.
function pframe_Callback(hObject, eventdata, handles)
set(handles.play_pause,'string','Play','Value',0);
refresh_screen(handles,-1);

function txt_Callback(hObject, eventdata, handles)

global timestamps

if isnan(str2double(get(hObject,'String')))
    set(handles.txt,'string',num2str(0));
end
if str2double(get(hObject,'String'))>size(timestamps,1)
    set(handles.txt,'string',num2str(size(timestamps,1)));
end


% --- Executes during object creation, after setting all properties.
function txt_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'),...
        get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


function refresh_screen(handles,jump) 

global PARAMETERS timestamps

ind=str2double(get(handles.txt,'string'));
if ind<size(timestamps,1) && ind+jump>0
    ind=ind+jump;
    set(handles.txt,'string',num2str(ind));
end

hO=get(handles.Omni);

if exist([PARAMETERS.folder,'OMNI'],'dir')
    if exist([PARAMETERS.folder,'OMNI/OMNI_',...
            num2str(timestamps(ind,1),'%3.6f'),'.png'],'file')
        imO=imread([PARAMETERS.folder,'OMNI/OMNI_',...
            num2str(timestamps(ind,1),'%3.6f'),'.png']);
        set(hO.Children,'CData',imO)
        set(handles.textO,'string',['Omni : ',num2str(timestamps(ind,1),'%3.4f'),' s']);
    end
end
drawnow;
