function varargout = svs(varargin)

%--------------------------------------------------------------------------
%                     RAWSEEDS VISUALIZATION TOOLKIT
%--------------------------------------------------------------------------
%   function  svs()
%
%   SVS loads the GUI for visualization of the stereo vision system's
%   images.
%
%   Authors: C. Cadena & J. Neira, University of Zaragoza, Spain
%--------------------------------------------------------------------------
%   Version: 1.0    nov-2010
%--------------------------------------------------------------------------
%   History:
%--------------------------------------------------------------------------

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       'svs', ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @svs_OpeningFcn, ...
                   'gui_OutputFcn',  @svs_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT

% --- Executes just before svs is made visible.
function svs_OpeningFcn(hObject, eventdata, handles, varargin)

handles.output = hObject;
guidata(hObject, handles);
im=imread('rawseeds.bmp');
axes(handles.svsT);
imshow(rgb2gray(im));
axes(handles.svsL);
imshow(rgb2gray(im));
axes(handles.svsR);
imshow(rgb2gray(im));

% --- Outputs from this function are returned to the command line.
function varargout = svs_OutputFcn(hObject, eventdata, handles)
varargout{1} = handles.output;


% --- Executes on button press in stop.
function stop_Callback(hObject, eventdata, handles)

set(handles.play_pause,'string','Play','Value',0);
set(handles.txt,'string','0');

% --- Executes on button press in play_pause.
function play_pause_Callback(hObject, eventdata, handles)

while get(hObject,'Value')
    refresh_screen(handles,1);
    if get(hObject,'Value')
        set(handles.play_pause,'string','Pause');
    else
        set(handles.play_pause,'string','Play');
    end
end

% --- Executes on button press in nframe.
function nframe_Callback(hObject, eventdata, handles)
set(handles.play_pause,'string','Play','Value',0);
refresh_screen(handles,1);

% --- Executes on button press in pframe.
function pframe_Callback(hObject, eventdata, handles)
set(handles.play_pause,'string','Play','Value',0);
refresh_screen(handles,-1);

function txt_Callback(hObject, eventdata, handles)

global timestamps

if isnan(str2double(get(hObject,'String')))
    set(handles.txt,'string',num2str(0));
end
if str2double(get(hObject,'String'))>size(timestamps,1)
    set(handles.txt,'string',num2str(size(timestamps,1)));
end


% --- Executes during object creation, after setting all properties.
function txt_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'),...
    get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


function refresh_screen(handles,jump) 

global PARAMETERS timestamps
    
ind=str2double(get(handles.txt,'string'));
if ind<size(timestamps,1) && ind+jump>0
    ind=ind+jump;
    set(handles.txt,'string',num2str(ind));
end

hT=get(handles.svsT);
hR=get(handles.svsR);
hL=get(handles.svsL);

if exist([PARAMETERS.folder,'SVS_T'],'dir')
    if exist([PARAMETERS.folder,'SVS_T/SVS_T_',...
            num2str(timestamps(ind,1),'%3.6f'),'.png'],'file')
        imT=imread([PARAMETERS.folder,'SVS_T/SVS_T_',...
            num2str(timestamps(ind,1),'%3.6f'),'.png']);
        set(hT.Children,'CData',imT)
        set(handles.textT,'string',['Top : ',num2str(timestamps(ind,1),'%3.4f'),' s']);
    end
end
if exist([PARAMETERS.folder,'SVS_L'],'dir')
    if exist([PARAMETERS.folder,'SVS_L/SVS_L_',...
            num2str(timestamps(ind,2),'%3.6f'),'.png'],'file')
        imL=imread([PARAMETERS.folder,'SVS_L/SVS_L_',...
            num2str(timestamps(ind,2),'%3.6f'),'.png']);
        set(hL.Children,'CData',imL)
        set(handles.textL,'string',['Left : ',num2str(timestamps(ind,2),'%3.4f'),' s']);
    end
end
if exist([PARAMETERS.folder,'SVS_R'],'dir')
    if exist([PARAMETERS.folder,'SVS_R/SVS_R_',...
            num2str(timestamps(ind,3),'%3.6f'),'.png'],'file')
        imR=imread([PARAMETERS.folder,'SVS_R/SVS_R_',...
            num2str(timestamps(ind,3),'%3.6f'),'.png']);
        set(hR.Children,'CData',imR)
        set(handles.textR,'string',['Right : ',num2str(timestamps(ind,3),'%3.4f'),' s']);
    end
end
drawnow;
