%--------------------------------------------------------------------------
%                    RAWSEEDS VISUALIZATION TOOLKIT
%                       http://www.rawseeds.org/
%--------------------------------------------------------------------------
%   svs_viewer.m
%
%   This script shows the images from the stereo vision system of the 
%   selected RAWSEEDS dataset.
% 
%   For more information, refer to the project site: www.rawseeds.org
%
%   Authors: C. Cadena & J. Neira, University of Zaragoza, Spain
%--------------------------------------------------------------------------
%   Version: 1.0    20-nov-2009
%--------------------------------------------------------------------------
%   History:
%--------------------------------------------------------------------------

close all;
clear all;

global PARAMETERS timestamps

PARAMETERS.DataPath      = '../datasets'; % where the datasets are?
  
% PARAMETERS.DatasetName   = 'Bicocca_2009-02-25a';  % Indoor
  PARAMETERS.DatasetName   = 'Bicocca_2009-02-25b';  % Indoor
% PARAMETERS.DatasetName   = 'Bicocca_2009-02-26a';  % Indoor
% PARAMETERS.DatasetName   = 'Bicocca_2009-02-26b';  % Indoor
% PARAMETERS.DatasetName   = 'Bicocca_2009-02-27a';  % Indoor
% PARAMETERS.DatasetName   = 'Bovisa_2008-09-01_Static';   % Mixed
% PARAMETERS.DatasetName   = 'Bovisa_2008-10-06_Dynamic';  % Mixed
% PARAMETERS.DatasetName   = 'Bovisa_2008-10-11a_Static';  % Mixed
% PARAMETERS.DatasetName   = 'Bovisa_2008-10-04_Static';   % Outdoor
% PARAMETERS.DatasetName   = 'Bovisa_2008-10-07_Dynamic';  % Outdoor
% PARAMETERS.DatasetName   = 'Bovisa_2008-10-11b_Static';  % Outdoor

%% import sensor
folder=[PARAMETERS.DataPath,'/',PARAMETERS.DatasetName,'/'];
dataset=PARAMETERS.DatasetName;
ind_=find(dataset=='_',1,'last');
if ind_>9, dataset=dataset(1:ind_-1); end

PARAMETERS.dataset=dataset;
PARAMETERS.folder=folder;

disp('--------------------------------------------------------------------');
disp('                 RAWSEEDS VISUALIZATION TOOLKIT                     ');
disp('--------------------------------------------------------------------');

tT_file=[dataset,'-LISTS/',dataset,'-SVS_T.csv'];
tL_file=[dataset,'-LISTS/',dataset,'-SVS_L.csv'];
tR_file=[dataset,'-LISTS/',dataset,'-SVS_R.csv'];

tT=importdata([folder,tT_file]);
tL=importdata([folder,tL_file]);
tR=importdata([folder,tR_file]);

smin=min([size(tT,1),size(tL,1),size(tR,1)]);

timestamps=[tT(1:smin,1),tL(1:smin,1),tR(1:smin,1)];

disp('--------------------------------------------------------------------');
disp('                 Viewing: Stereo Vision System                      ');
disp('--------------------------------------------------------------------');

svs;

